#include "mainframe.h"
#include "AboutDialog.h"
#include <wx/wfstream.h>
#include <wx/zstream.h>
#include <wx/filename.h>
#include <wx/xml/xml.h>

int idBtnBrwse1=wxNewId(),idBtnBrwse2=wxNewId(),idBtnBrwse3=wxNewId(),idBtnBrwse4=wxNewId(),idBtnBrwse5=wxNewId();

BEGIN_EVENT_TABLE(MainFrame,wxFrame)
    EVT_BUTTON(idBtnBrwse1,MainFrame::OnBtnBrwseClicked)
    EVT_BUTTON(idBtnBrwse2,MainFrame::OnBtnBrwseClicked)
    EVT_BUTTON(idBtnBrwse3,MainFrame::OnBtnBrwseClicked)
    EVT_BUTTON(idBtnBrwse4,MainFrame::OnBtnBrwseClicked)
    EVT_BUTTON(idBtnBrwse5,MainFrame::OnBtnBrwseClicked)
    EVT_BUTTON(wxID_ABOUT,MainFrame::OnBtnAboutClicked)
    EVT_BUTTON(wxID_OK,MainFrame::OnBtnCreateClicked)
    EVT_BUTTON(wxID_EXIT,MainFrame::OnBtnExitClicked)
    EVT_BUTTON(wxID_SAVE,MainFrame::OnBtnSaveParamsClicked)
END_EVENT_TABLE()

MainFrame::MainFrame() : wxFrame(NULL,-1,_T("ZSKreator (v1)"))
{
    SetIcon(wxICON(IDI_MAINICON));
    wxPanel* mainpanel;

    wxStaticText* label;
    wxButton* btnBrwse;
    wxStaticBoxSizer* sizer1;
    wxBoxSizer* sizer2;

    mainpanel=new wxPanel(this,-1);

    wxBoxSizer *mainsizer=new wxBoxSizer(wxVERTICAL);

    wxBoxSizer* topsizer=new wxBoxSizer(wxHORIZONTAL);
        sizer1=new wxStaticBoxSizer(wxVERTICAL,mainpanel,_T("Fichiers images et fichier  crer : "));
            label=new wxStaticText(mainpanel,-1,_T("Image masque : Image en noir et blanc dfinissant la forme qu'aura la skin.\n  Les parties blanches seront transparentes, et les parties noires seront affiches."));
            sizer1->Add(label,0,wxLEFT|wxRIGHT|wxEXPAND,5);
            sizer2=new wxBoxSizer(wxHORIZONTAL);
                txtImgMask=new wxTextCtrl(mainpanel,-1,_T(""));
                sizer2->Add(txtImgMask,1,wxLEFT|wxBOTTOM|wxALIGN_CENTRE_VERTICAL,5);
                btnBrwse=new wxButton(mainpanel,idBtnBrwse1,_T("Parcourir"));
                sizer2->Add(btnBrwse,0,wxLEFT|wxRIGHT|wxBOTTOM|wxEXPAND,5);
            sizer1->Add(sizer2,0,wxLEFT|wxRIGHT|wxBOTTOM|wxEXPAND,0);
            label=new wxStaticText(mainpanel,-1,_T("Image normale : Image de la skin \"au repos\", c'est  dire avec les boutons non\n  presss, et non mis en vidence par le passage de la souris au dessus d'eux."));
            sizer1->Add(label,0,wxLEFT|wxRIGHT|wxEXPAND,5);
            sizer2=new wxBoxSizer(wxHORIZONTAL);
                txtImgNormal=new wxTextCtrl(mainpanel,-1,_T(""));
                sizer2->Add(txtImgNormal,1,wxLEFT|wxBOTTOM|wxALIGN_CENTRE_VERTICAL,5);
                btnBrwse=new wxButton(mainpanel,idBtnBrwse2,_T("Parcourir"));
                sizer2->Add(btnBrwse,0,wxLEFT|wxRIGHT|wxBOTTOM|wxEXPAND,5);
            sizer1->Add(sizer2,0,wxLEFT|wxRIGHT|wxBOTTOM|wxEXPAND,0);
            label=new wxStaticText(mainpanel,-1,_T("Image active : Image de la skin avec les boutons presss"));
            sizer1->Add(label,0,wxLEFT|wxRIGHT|wxEXPAND,5);
            sizer2=new wxBoxSizer(wxHORIZONTAL);
                txtImgPressed=new wxTextCtrl(mainpanel,-1,_T(""));
                sizer2->Add(txtImgPressed,1,wxLEFT|wxBOTTOM|wxALIGN_CENTRE_VERTICAL,5);
                btnBrwse=new wxButton(mainpanel,idBtnBrwse3,_T("Parcourir"));
                sizer2->Add(btnBrwse,0,wxLEFT|wxRIGHT|wxBOTTOM|wxEXPAND,5);
            sizer1->Add(sizer2,0,wxLEFT|wxRIGHT|wxBOTTOM|wxEXPAND,0);
            label=new wxStaticText(mainpanel,-1,_T("Image \"hover\" : Image de la skin avec les boutons mis en vidence lorsque la\n  souris passe au dessus de l'un d'eux.\nCette image est optionnelle. Si la zone ci-dessous reste vide, cette fonction\n  de la skin ne sera tout simplement pas prise en compte."));
            sizer1->Add(label,0,wxLEFT|wxRIGHT|wxEXPAND,5);
            sizer2=new wxBoxSizer(wxHORIZONTAL);
                txtImgHover=new wxTextCtrl(mainpanel,-1,_T(""));
                sizer2->Add(txtImgHover,1,wxLEFT|wxBOTTOM|wxALIGN_CENTRE_VERTICAL,5);
                btnBrwse=new wxButton(mainpanel,idBtnBrwse4,_T("Parcourir"));
                sizer2->Add(btnBrwse,0,wxLEFT|wxRIGHT|wxBOTTOM|wxEXPAND,5);
            sizer1->Add(sizer2,0,wxLEFT|wxRIGHT|wxBOTTOM|wxEXPAND,0);
            label=new wxStaticText(mainpanel,-1,_T("Nom du fichier  crer. Il vous suffira de copier ce fichier dans le sous-dossier\n  \"Skins\" de l'application pour qu'il soit pris en compte."));
            sizer1->Add(label,0,wxLEFT|wxRIGHT|wxTOP|wxEXPAND,5);
            sizer2=new wxBoxSizer(wxHORIZONTAL);
                txtFOut=new wxTextCtrl(mainpanel,-1,_T(""));
                sizer2->Add(txtFOut,1,wxLEFT|wxBOTTOM|wxALIGN_CENTRE_VERTICAL,5);
                btnBrwse=new wxButton(mainpanel,idBtnBrwse5,_T("Parcourir"));
                sizer2->Add(btnBrwse,0,wxLEFT|wxRIGHT|wxBOTTOM|wxEXPAND,5);
            sizer1->Add(sizer2,0,wxLEFT|wxRIGHT|wxBOTTOM|wxEXPAND,0);
        topsizer->Add(sizer1,0,wxALL|wxEXPAND,5);

        sizer1=new wxStaticBoxSizer(wxVERTICAL,mainpanel,_T("Taille et position des contrles : "));
        const wxString szLabel1[6]={_T("Bouton \"Fermeture de la fentre\":"),
                                 _T("Bouton \"Rduction de la fentre\":"),
                                 _T("Bouton \"Rglages\":"),
                                 _T("Bouton \"Actualiser\":"),
                                 _T("Bouton \"A propos de...\":"),
                                 _T("Fentre d'affichage des donnes:")};
        const wxString szLabel2[4]={_T("Pos.X:"),_T("Pos.Y:"),_T("Larg.:"),_T("Haut.:")};
        for (int i=0;i<6;i++)
        {
            label=new wxStaticText(mainpanel,-1,szLabel1[i]);
            sizer1->Add(label,0,wxLEFT|wxRIGHT|wxEXPAND,5);
            sizer2=new wxBoxSizer(wxHORIZONTAL);
                for (int j=0;j<4;j++)
                {
                    label=new wxStaticText(mainpanel,-1,szLabel2[j]);
                    sizer2->Add(label,0,wxLEFT|wxALIGN_CENTRE_VERTICAL,5);
                    txtPos[j][i]=new wxTextCtrl(mainpanel,-1,_T(""),wxDefaultPosition,wxSize(40,-1));
                    sizer2->Add(txtPos[j][i],0,wxEXPAND,0);
                }
            sizer1->Add(sizer2,0,wxLEFT|wxRIGHT|wxBOTTOM|wxEXPAND,5);
        }
        // On dsactive et on renseigne la taille de la fentre d'affichage des rsultats
        txtPos[2][5]->Enable(false);
        txtPos[2][5]->SetValue(_T("400"));
        txtPos[3][5]->Enable(false);
        txtPos[3][5]->SetValue(_T("280"));
        topsizer->Add(sizer1,0,wxTOP|wxRIGHT|wxBOTTOM|wxEXPAND,5);
    mainsizer->Add(topsizer,0,wxALL|wxEXPAND,0);
    const int iBtnCount=3;
    //const wxString szBtn[iBtnCount]={_T("Eclater une skin"),_T("Ouvrir un fichier paramtres"),_T("Enregistrer les paramtres"),_T("Gnrer la Skin"),_T("A propos de..."),_T("Quitter")};
    //const int idBtn[iBtnCount]={wxID_REVERT,wxID_OPEN,wxID_SAVE,wxID_OK,wxID_ABOUT,wxID_EXIT};
    const wxString szBtn[iBtnCount]={_T("Gnrer la Skin"),_T("A propos de..."),_T("Quitter")};
    const int idBtn[iBtnCount]={wxID_OK,wxID_ABOUT,wxID_EXIT};
    wxButton *btn;
    wxStaticBoxSizer* bottomsizer=new wxStaticBoxSizer(wxHORIZONTAL,mainpanel,_T("Commandes : "));
        bottomsizer->AddStretchSpacer();
        for (int i=0;i<iBtnCount;i++)
        {
            btn=new wxButton(mainpanel,idBtn[i],szBtn[i]);
            bottomsizer->Add(btn,0,wxLEFT|wxRIGHT|wxBOTTOM,5);
            //if ((i==0)||(i==1)) btn->Enable(false);
        }

    mainsizer->Add(bottomsizer,5,wxLEFT|wxRIGHT|wxBOTTOM|wxEXPAND,5);
    mainpanel->SetSizer(mainsizer);
    mainsizer->SetSizeHints(this);
}

MainFrame::~MainFrame()
{
    //dtor
}

void MainFrame::OnBtnBrwseClicked(wxCommandEvent& event)
{
    int iID=event.GetId();
    wxString sMsg,sWldCrd;
    long lStyle;
    if (iID==idBtnBrwse5)
    {
        sMsg=_T("Entrez le nom du fichier skin  crer.");
        sWldCrd=_T("Fichiers skins|*.zsk");
        lStyle=wxFD_SAVE|wxFD_OVERWRITE_PROMPT;
    } else {
        sMsg=_T("Slectionnez un fichier image");
        sWldCrd=_T("Fichiers images|*.bmp;*.gif;*.jpg;*.png;*.xpm");
        lStyle=wxFD_OPEN|wxFD_FILE_MUST_EXIST;
    }

    wxFileDialog fdlg(this,sMsg,_T(""),_T(""),sWldCrd,lStyle);
    if (fdlg.ShowModal()==wxID_CANCEL) return;
    wxTextCtrl* txtResult=((iID==idBtnBrwse1)?txtImgMask:((iID==idBtnBrwse2)?txtImgNormal:((iID==idBtnBrwse3)?txtImgPressed:((iID==idBtnBrwse4)?txtImgHover:txtFOut))));
    txtResult->SetValue(fdlg.GetPath());
}

void MainFrame::OnBtnAboutClicked(wxCommandEvent& event)
{
    AboutDialog dlg(this);
    dlg.ShowModal();
}

void MainFrame::OnBtnCreateClicked(wxCommandEvent& event)
{
    wxString sImgFName;
    wxImage imgMask,imgNorm,imgPress,imgHover;
    bool bImgHover;
    // Vrification de l'image masque
    sImgFName=txtImgMask->GetValue();
    if (sImgFName.IsEmpty())
    {
        wxMessageBox(_T("Vous n'avez pas spcifi d'image \"masque\"..."));
        return;
    }
    if (!imgMask.LoadFile(sImgFName))
    {
        wxMessageBox(_T("Imposible de charger le fichier image \"masque\"."));
        return;
    }
    // Vrification de l'image normale
    sImgFName=txtImgNormal->GetValue();
    if (sImgFName.IsEmpty())
    {
        wxMessageBox(_T("Vous n'avez pas spcifi d'image \"normale\"..."));
        return;
    }
    if (!imgNorm.LoadFile(sImgFName))
    {
        wxMessageBox(_T("Imposible de charger le fichier image \"normale\"."));
        return;
    }
    if ((imgNorm.GetWidth()!=imgMask.GetWidth())||(imgNorm.GetHeight()!=imgMask.GetHeight()))
    {
        wxMessageBox(_T("Le fichier image \"normale\" n'a pas le mme taille que le fichier image \"masque\"."));
        return;
    }
    // Vrification de l'image "boutons activs"
    sImgFName=txtImgPressed->GetValue();
    if (sImgFName.IsEmpty())
    {
        wxMessageBox(_T("Vous n'avez pas spcifi d'image \"active\"..."));
        return;
    }
    if (!imgPress.LoadFile(sImgFName))
    {
        wxMessageBox(_T("Imposible de charger le fichier image \"active\"."));
        return;
    }
    if ((imgPress.GetWidth()!=imgMask.GetWidth())||(imgPress.GetHeight()!=imgMask.GetHeight()))
    {
        wxMessageBox(_T("Le fichier image \"active\" n'a pas le mme taille que le fichier image \"masque\"."));
        return;
    }
    // Vrification de l'image "hover"
    sImgFName=txtImgHover->GetValue();
    if (sImgFName.IsEmpty())
    {
        bImgHover=false;
    } else {
        bImgHover=true;
        if (!imgHover.LoadFile(sImgFName))
        {
            wxMessageBox(_T("Imposible de charger le fichier image \"hover\"."));
            return;
        }
        if ((imgHover.GetWidth()!=imgMask.GetWidth())||(imgHover.GetHeight()!=imgMask.GetHeight()))
        {
            wxMessageBox(_T("Le fichier image \"hover\" n'a pas le mme taille que le fichier image \"masque\"."));
            return;
        }
    }
    // Vrification du bouton Fermeture
    // Vrification du bouton Rduction
    // Vrification du bouton Rglages
    // Vrification du bouton Actualiser
    // Vrification du bouton A propos
    // Vrification de la HtmlWindow

    // Vrifier le nom du fichier  crer
    wxFileName zskFName=txtFOut->GetValue();
    if (!zskFName.IsOk())
    {
        wxMessageBox(_T("Vous n'avez pas saisi de nom de fichier correct pour la cration de la skin."));
        return;
    }

    // Si on arrive ici, c'est que tout est ok
    // On peut donc crer le fichier skin correspondant
    wxString sOutFName=zskFName.GetFullPath(),sVal;
    // Cration du fichier
    wxFileOutputStream fout(sOutFName);
    wxZlibOutputStream zout(fout,9);
    int iW,iH,iVal;

    if (bImgHover) iVal=1; else iVal=0;
    zout.Write(&iVal,sizeof(int)); // Numro de version de la skin  crer
    // Dimensions de la skin en pixels
    iW=imgMask.GetWidth();
    iH=imgMask.GetHeight();
    zout.Write(&iW,sizeof(int));
    zout.Write(&iH,sizeof(int));
    // Image Masque
    zout.Write(imgMask.GetData(),iW*iH*3);
    // Image Normale
    zout.Write(imgNorm.GetData(),iW*iH*3);
    // Image Active
    zout.Write(imgPress.GetData(),iW*iH*3);
    // Image Hover si spcifie
    if (bImgHover)
    {
        zout.Write(imgHover.GetData(),iW*iH*3);
    }
    // Positions et taille des contrles
    long l;
    for (int j=0;j<6;j++)
    {
        for (int i=0;i<((j==5)?2:4);i++)
        {
            l=0;
            sVal=txtPos[i][j]->GetValue();
            sVal.ToLong(&l);
            iVal=int(l);
            //wxMessageBox(wxString::Format(_T("Pos[%d][%d]=%d (\"%s\")."),i,j,iVal,sVal.c_str()));
            zout.Write(&iVal,sizeof(int));
        }
    }
    zout.Close();
    fout.Close();
    wxMessageBox(_T("Le fichier skin a t cr avec succs !"));
}

void MainFrame::OnBtnExitClicked(wxCommandEvent& event)
{
    Close();
}

void MainFrame::OnBtnSaveParamsClicked(wxCommandEvent& event)
{
    wxFileDialog fdlg(this,_T("Entrez le nom du fichier  crer."),_T(""),_T(""),_T("Fichiers xml|*.xml"),wxFD_SAVE|wxFD_OVERWRITE_PROMPT);
    if (fdlg.ShowModal()==wxID_CANCEL) return;
    wxString sFName=fdlg.GetPath();
    //wxXmlDocument doc;
}
