// Fichier Main.cpp
#include "MyApp.h"
#include "MainFrame.h"
#include "Settings.h"
#include <wx/fs_mem.h>
#include <wx/image.h>
Settings MyOptions;

/* TODO (Maestro#1#): Modifier la boite de dialogue "A propos de..."
  - Penser au logo "Powered by wxWidgets"
  - Penser galement au lien vers MeteoFrance.com */
/* TODO (Maestro#1#): Module de mise  jour automatique par internet */
/* TODO (Maestro#1#): Ajouter un SplashScreen */

IMPLEMENT_APP(MyApp);

bool MyApp::OnInit()
{
    m_dial = wxDialUpManager::Create();
    wxFileSystem::AddHandler(new wxMemoryFSHandler);
    wxInitAllImageHandlers();
    wxFileName sAppFName=(wxString)(this->argv[0]);
    MyOptions.sAppPath=sAppFName.GetPath();
    if (MyOptions.sAppPath.Last()!='\\') MyOptions.sAppPath.Append('\\');
    MyOptions.ReadSettings();
	MainFrame* frame = new MainFrame();
	frame->Show();
	return true;
}

int MyApp::OnExit()
{
    if (m_dial!=NULL) delete m_dial;
    MyOptions.SaveSettings();
}
