#ifndef OPTIONSDIALOG_H_INCLUDED
#define OPTIONSDIALOG_H_INCLUDED

#include <wx/wxprec.h>

#ifndef WX_PRECOMP
    #include <wx/wx.h>
#endif

class OptionsDialog : public wxDialog
{
public:
    OptionsDialog(wxWindow *Parent);
    ~OptionsDialog();
    bool SetDepartement(int DprtNum);
    bool SetVille(int iVille);
    bool SetSkin(wxString SkinName);
    wxString GetSkin();
protected:
private:
    wxStaticBox *fraMain,*fraSkin;
    wxStaticText *lblDprt,*lblTown,*lblSkin;
    wxComboBox *cmbDprt,*cmbTown,*cmbSkin;
    wxButton *btnOk,*btnCancel;
    void UpdateTownComboBox();
    void OnDprtChanged(wxCommandEvent &event);
    void OnTownChanged(wxCommandEvent &event);
    void OnSkinChanged(wxCommandEvent &event);
    void OnOkPressed(wxCommandEvent &event);
    void OnCancelPressed(wxCommandEvent &event);
    int iCurDprt,iCurVille;
    wxString sCurSkin;
    DECLARE_EVENT_TABLE();
};

#endif // OPTIONSDIALOG_H_INCLUDED
