#ifndef SKIN_H_INCLUDED
#define SKIN_H_INCLUDED
#include <wx/wxprec.h>

#ifndef WX_PRECOMP
    #include <wx/wx.h>
#endif
#include <wx/image.h>
#define BUTTONS_COUNT 5
enum BUTTONS_NAMES
{
    BTN_CLOSE=0,
    BTN_MINIMIZE,
    BTN_OPTIONS,
    BTN_UPDATE,
    BTN_ABOUT
};
enum BUTTONS_STATES
{
    BTN_STATE_NORMAL=0,
    BTN_STATE_PRESSED,
    BTN_STATE_HOVER
};

class Skin
{
public:
    Skin();
    virtual ~Skin();
    bool IsOk();
    bool Read(wxString sFName);
    wxSize GetSize();
    wxImage GetButtonImage(int iBtnIndex,int ButtonState=BTN_STATE_NORMAL);
    wxBitmap GetMaskBitmap();
    wxBitmap GetMainBitmap();
    wxRect GetButtonRect(int iBtnIndex);
    wxPoint GetScreenPos();
    int GetSkinVersion();
protected:
private:
    bool m_bIsOk;
    int m_iVersion;
    wxSize m_bmpsize;
    wxRect m_btnrect[5];
    wxPoint m_brwsrpos;
    wxImage m_imgMask,m_imgUp,m_imgDown,m_imgHover;
};

#endif // SKIN_H_INCLUDED
