#ifndef MYAPP_H_INCLUDED
#define MYAPP_H_INCLUDED

#include <wx/wxprec.h>

#ifndef WX_PRECOMP
    #include <wx/wx.h>
#endif
#include "wx/dialup.h"

class MyApp : public wxApp
{
public:
    virtual bool OnInit();
    virtual int OnExit();
    wxDialUpManager *GetDialer() const { return m_dial; }
private:
    wxDialUpManager *m_dial;
};

DECLARE_APP(MyApp)

#endif  //MYAPP_H_INCLUDED
